# Example Xp Earning/Level Gaining
#Example Written By: J3ff Hoogland

#Lets import everything we want to use to make our mod work:
#Event Scripts
import es
#Used for loading our saved data(if it exists)
import os.path
#Used for saving our data currently in memory
import cPickle
#First lets set our global values that will contain how much xp we will be getting/needing for different things
killxp = 50
headshotxp = 30
knifexp = 100
levelinterval = 250
#This line here is important it creates our dictonary - where we will save our user data to during run time
Players = {}
#The block of come we run on server start
def load():
	#Allow this local fn to read the Players dic
	global Players
	#This line here saves the file path of our addon and then adds the name of our stored file at the end of it
	str_path = es.getAddonPath('xp') + '/Players.db'
	#Check if that stored file exists in the path given
	if os.path.isfile(str_path):
		#If it does we now use cPickle to open it
		file_users = open(str_path)
		#Bring it into memory using our Players dic
		Players = cPickle.load(file_users)
		# It is always good habbit to close our file when we are done with it
		file_users.close()
#This runs every time a player joins our server
def player_activate(event_var):
	#Allow this local fn to read the Players dic
	global Players
	#Check to see if the connecting player already has a key in our dic
	if not Players.has_key(event_var['es_steamid']):
		#If they do not lets make them one
		#This line creates a dic with the steamid of our player within the dic 'Players'
		Players[event_var['es_steamid']] = {}
		#Now lets set some values to this new key we have created - Default level and starting xp
		Players[event_var['es_steamid']]['xp'] = 0
		Players[event_var['es_steamid']]['level'] = 1
#This block of code runs of us each time a players ends up dead :)
def player_death(event_var):
	#Lets make sure the killer and the victim where on different teams before we give them some Xp
	if event_var['es_userteam'] != event_var['es_attackerteam']:
		#Call up our global vars: The Players dic and our xp setting vars
		global Players
		global killxp
		global headshotxp
		global knifexp
		#Call up the users current xp and then add the killxp value to it
		xp = Players[event_var['es_attackersteamid']]['xp'] + killxp
		#Let the user know they got a kill
		es.tell(event_var['attacker'], '#lightgreen', 'You have obtained %i xp for scoring a kill!'%killxp)
		#Check to see if the kill was a headshot
		if event_var['headshot'] == '1':
			#if it was a headshot lets add the head shot xp to their xp also
			xp += headshotxp
			es.tell(event_var['attacker'], '#lightgreen', 'You have gained %i bonus xp for scoring a headshot kill!'%headshotxp)
		#Check to see if the kill was made with a knife
		if event_var['weapon'] == 'knife':
			#If it was lets give them some extra xp for shanking a guy :)
			xp += knifexp
			es.tell(event_var['attacker'], '#lightgreen', 'You have gained %i bonus xp for scoring a kill with a knife'%knifexp)
		#Lets store our user's new Xp values
		Players[event_var['es_attackersteamid']]['xp'] = xp
		#Lets run a block to see if our user has enough Xp to gain a level!
		level_up_check(event_var['attacker'], event_var['es_attackersteamid'])
#block checks to see if the user you pass through it has enough xp to gain a level
def level_up_check(userid, steamid):
	#Global our Players Dic and our leveinterval amount
	global Players
	global levelinterval
	#Call up our users xp and level
	level = Players[steamid]['level']
	xp = Players[steamid]['xp']
	#Do a math fn to find the amount of xp needed to gain a level
	xpneeded = level * levelinterval
	#Check to see if the users current xp is greater than the xp needed to obtain his/her next level
	if xp >= xpneeded:
		#if it is lets level them up!
		#Subtract the xpneeded to level from their current xp
		xp -= xpneeded
		#Add one to their level
		level += 1
		#Save their new level and xp
		Players[steamid]['xp'] = xp
		Players[steamid]['level'] = level
		#Let the user know they gained a level
		es.tell(userid, '#multi', '#defaultYou have advanded to #lightgreenLevel #default: #green%i'%level)
#block runs each time a round ends
def round_end(event_var):
	#Lets save our Players dic to a file so we can read from it later if need be :)
	#global our Players dic
	global Players
	#Get the addon path for the pluggin and the user file name, the 'w' means we want to write to this file it also creates the file if one does not already exists
	str_path = open(es.getAddonPath('xp') + '/Players.db', 'w')
	#Drops the Players dic into a file and saves it
	cPickle.dump(Players, str_path)
	#Close the file when we are done with it
	str_path.close()
#runs every time something is said in chat
def player_say(event_var):
	#checks to see if our user said the key word !xp
	if event_var['text'] == '!xp':
		#If they did lets tell them how much xp they have and what level they are and how much xp they need to obtain that next level
		#global the Players dic and the levelinterval value
		global Players
		#Call up their level and current xp
		level = Players[event_var['es_steamid']]['level']
		xp = Players[event_var['es_steamid']]['xp']
		xpneeded = level * levelinterval
		#Tell the user this information
		es.tell(event_var['userid'], '#lightgreen', 'You are Level: %i With %i/%i Xp.'%(level, xp, xpneeded))